#region License Information
/* HeuristicLab
 * Copyright (C) 2002-2010 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
 *
 * This file is part of HeuristicLab.
 *
 * HeuristicLab is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * HeuristicLab is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
 */
#endregion

using System;
using System.Windows.Forms;
using HeuristicLab.Clients.Common;
using HeuristicLab.Clients.OKB.AdminService;
using HeuristicLab.MainForm;
using HeuristicLab.PluginInfrastructure;

namespace HeuristicLab.Clients.OKB {
  [View("OKB Administration")]
  public partial class AdministrationView : HeuristicLab.MainForm.WindowsForms.View {
    public AdministrationView() {
      InitializeComponent();
    }

    private void refreshAlgorithmClassesButton_Click(object sender, EventArgs e) {
      using (AdminServiceClient adminService = ClientFactory.CreateClient<AdminServiceClient, IAdminService>()) {
        try {
          algorithmClassCollectionView.Content = new EntityCollection<AlgorithmClass>(adminService.GetAlgorithmClasses());
        }
        catch (Exception ex) {
          ErrorHandling.ShowErrorDialog(ex);
        }
      }
    }

    private void refreshAlgorithmsButton_Click(object sender, EventArgs e) {
      using (AdminServiceClient adminService = ClientFactory.CreateClient<AdminServiceClient, IAdminService>()) {
        try {
          algorithmCollectionView.Content = new EntityCollection<Algorithm>(adminService.GetAlgorithms());
        }
        catch (Exception ex) {
          ErrorHandling.ShowErrorDialog(ex);
        }
      }
    }
  }
}
